/**********************************************************************
*
*    eval11.c
*    ========
*
*    This file is part of the VARKON Program Module Library.
*    URL: http://www.varkon.com
*
*    This file includes the following routines:
*
*    evappf();     Evaluerar APPEND_FILE
*    evdelf();     Evaluerar DELETE_FILE
*    evmovf();     Evaluerar MOVE_FILE
*    evcopf();     Evaluerar COPY_FILE
*    evtstf();     Evaluerar TEST_FILE
*    evgenv();     Evaluerar GET_ENVIRONMENT
*
*    This library is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Library General Public
*    License as published by the Free Software Foundation; either
*    version 2 of the License, or (at your option) any later version.
*
*    This library is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Library General Public License for more details.
*
*    You should have received a copy of the GNU Library General Public
*    License along with this library; if not, write to the Free
*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    (C)Microform AB 1984-1999, Johan Kjellander, johan@microform.se
*
***********************************************************************/

#include "../../DB/include/DB.h"
#include "../../IG/include/IG.h"
#include <string.h>

/*!******************************************************/

        short evappf(PMPARVA pv[])

/*      Evaluerar APPEND_FILE.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Felkod: 
 *
 *      (C)microform ab 1996-01-26 J. Kjellander
 *
 ******************************************************!*/

 {
   return(v3fapp(pv[1].par_va.lit.str_va,pv[2].par_va.lit.str_va));
 }

/********************************************************/
/*!******************************************************/

        short evdelf(PMPARVA pv[])

/*      Evaluerar DELETE_FILE.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Felkod: 
 *
 *      (C)microform ab 1996-01-26 J. Kjellander
 *
 ******************************************************!*/

 {
   return(v3fdel(pv[1].par_va.lit.str_va));
 }

/********************************************************/
/*!******************************************************/

        short evmovf(PMPARVA pv[])

/*      Evaluerar MOVE_FILE.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Felkod: 
 *
 *      (C)microform ab 1996-01-26 J. Kjellander
 *
 ******************************************************!*/

 {
   return(v3fmov(pv[1].par_va.lit.str_va,pv[2].par_va.lit.str_va));
 }

/********************************************************/
/*!******************************************************/

        short evcopf(PMPARVA pv[])

/*      Evaluerar COPY_FILE.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Felkod: 
 *
 *      (C)microform ab 1996-01-26 J. Kjellander
 *
 ******************************************************!*/

 {
   return(v3fcpy(pv[1].par_va.lit.str_va,pv[2].par_va.lit.str_va));
 }

/********************************************************/
/*!******************************************************/

        short evtstf(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar TEST_FILE.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde.
 *
 *      Felkod: 
 *
 *      (C)microform ab 1996-01-26 J. Kjellander
 *
 ******************************************************!*/

 {
   char  mode;
   char *path;
   int   status;

   path = pv[1].par_va.lit.str_va;
   mode = pv[2].par_va.lit.str_va[0];

   if ( v3facc(path,mode) ) status = 1;
   else                     status = 0;

   valp->lit.int_va = status;

   return(0);
 }

/********************************************************/
/*!******************************************************/

        short evgenv(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar GET_ENVIRONMENT.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde.
 *
 *      Felkod: 
 *
 *      (C)microform ab 1996-01-26 J. Kjellander
 *
 ******************************************************!*/

 {
   char *strpek;

/*
***Prova att hmta.
*/
   strpek = gtenv3(pv[1].par_va.lit.str_va);
/*
***Om den inte finns returnerar vi tom strng "".
*/ 
   if ( strpek == NULL ) valp->lit.str_va[0] = '\0';
/*
***Finns den gr vi sker kopiering. Max. V3STRLEN tecken.
*/
   else
     {
     strncpy(valp->lit.str_va,strpek,V3STRLEN);
     valp->lit.str_va[V3STRLEN] = '\0';
     }

   return(0);
 }

/********************************************************/
