/**********************************************************************
*
*    eval5.c
*    =======
*
*    This file is part of the VARKON Program Module Library.
*    URL: http://www.varkon.com
*
*    This file includes the following routines:
*
*    evalev();     Evaluates ACT_LEV
*    evablk();     Evaluates ACT_BLANK
*    evavin();     Evaluates ACT_VNAM
*    evapen();     Evaluates ACT_PEN
*    evawdt();     Evaluates ACT_WIDTH
*    evascl();     Evaluates ACT_SCL
*    evadsc();     Evaluates ACT_DSCL
*    evacac();     Evaluates ACT_CACC
*    evagrx();     Evaluates ACT_GRIDX
*    evagry();     Evaluates ACT_GRIDY
*    evagdx();     Evaluates ACT_GRIDDX
*    evagdy();     Evaluates ACT_GRIDDY
*    evagrd();     Evaluates ACT_GRID
*    evajbn();     Evaluates ACT_JOBNAM
*    evamtp();     Evaluates ACT_MTYPE
*    evamat();     Evaluates ACT_MATTR
*    evajbd();     Evaluates ACT_JOBDIR
*    evalft();     Evaluates ACT_LFONT
*    evaaft();     Evaluates ACT_AFONT
*    evacft();     Evaluates ACT_CFONT
*    evaxft();     Evaluates ACT_XFONT
*    evaldl();     Evaluates ACT_LDASHL
*    evaadl();     Evaluates ACT_ADASHL
*    evacdl();     Evaluates ACT_CDASHL
*    evaxdl();     Evaluates ACT_XDASHL
*    evatsi();     Evaluates ACT_TSIZE
*    evatwi();     Evaluates ACT_TWIDTH
*    evatsl();     Evaluates ACT_TSLANT
*    evadts();     Evaluates ACT_DTSIZ
*    evadas();     Evaluates ACT_DASIZ
*    evadnd();     Evaluates ACT_DNDIG
*    evadau();     Evaluates ACT_DAUTO
*    evacsy();     Evaluates ACT_CSY
*    evapid();     Evaluates ACT_PID
*    evavvr();     Evaluates ACT_VARKON_VERS
*    evavsr();     Evaluates ACT_VARKON_SERIAL
*    evaost();     Evaluates ACT_OSTYPE
*    evahst();     Evaluates ACT_HOST
*    evcrnp();     Evaluates CRAY_NUM_PES
*    evcrmp();     Evaluates CRAY_MY_PE
*
*    This library is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Library General Public
*    License as published by the Free Software Foundation; either
*    version 2 of the License, or (at your option) any later version.
*
*    This library is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Library General Public License for more details.
*
*    You should have received a copy of the GNU Library General Public
*    License along with this library; if not, write to the Free
*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    (C)Microform AB 1984-1999, Johan Kjellander, johan@microform.se
*
***********************************************************************/

#include "../../DB/include/DB.h"
#include "../../IG/include/IG.h"
#include "../../GP/include/GP.h"

#ifdef UNIX
#include <sys/utsname.h>
#endif

extern V2NAPA defnap;
extern V3MDAT sydata;
extern gmflt  rstrox,rstroy,rstrdx,rstrdy;
extern bool   rstron;
extern double curnog,ritskl,gpgszx;
extern char   pidnam[],jobnam[],jobdir[];
extern pm_ptr actmod;
extern DBptr  lsysla;

/*!******************************************************/

        short evalev(PMLITVA *valp)

/*      Evaluerar funktionen ACT_LEV.
 *
 *      In: Inget.
 *
 *      Ut: *valp = Aktiv niv.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/5/86 R. Svedin
 *
 *      31/10/86 Nytt namn och flyttad frn eval3.c, R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.level;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evablk(PMLITVA *valp)

/*      Evaluerar funktionen ACT_BLANK.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv blank, tnd/slckt.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.blank;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evavin(PMLITVA *valp)

/*      Evaluerar funktionen ACT_VNAM.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv vy.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {
    VY    actwin;

    gpgwin(&actwin);
    strcpy(valp->lit.str_va , actwin.vynamn);

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evapen(PMLITVA *valp)

/*      Evaluerar funktionen ACT_PEN.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv penna.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.pen;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evawdt(PMLITVA *valp)

/*      Evaluerar funktionen ACT_WIDTH.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv linjebredd.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 1998-01-01, J.Kjellander
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.width;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evascl(PMLITVA *valp)

/*      Evaluerar funktionen ACT_SCL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv skala.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    VY     actwin;
    double skala;

    gpgwin(&actwin);
    skala=gpgszx / (actwin.vywin[2]-actwin.vywin[0]);
    valp->lit.float_va = skala;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evadsc(PMLITVA *valp)

/*      Evaluerar funktionen ACT_DSCL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv ritningsskala.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = ritskl;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evacac(PMLITVA *valp)

/*      Evaluerar funktionen ACT_CACC.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv kurvnoggrannhet.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = curnog;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evagrx(PMLITVA *valp)

/*      Evaluerar funktionen ACT_GRIDX.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv rasterposition i X-led.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = rstrox;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evagry(PMLITVA *valp)

/*      Evaluerar funktionen ACT_GRIDY.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv rasterposition i Y-led.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = rstroy;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evagdx(PMLITVA *valp)

/*      Evaluerar funktionen ACT_GRIDDX.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv rasterdelning i X-led.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = rstrdx;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evagdy(PMLITVA *valp)

/*      Evaluerar funktionen ACT_GRIDDY.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv rasterdelning i Y-led.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = rstrdy;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evagrd(PMLITVA *valp)

/*      Evaluerar funktionen ACT_GRID.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Raster aktivt/ej aktivt.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {
    short i;

    if ( rstron ) i = 1;
    else i = 0;

    valp->lit.int_va = i;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evajbn(PMLITVA *valp)

/*      Evaluerar funktionen ACT_JOBNAM.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt jobbnamn.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    strcpy(valp->lit.str_va , jobnam);

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evamtp(PMLITVA *valp)

/*      Evaluerar funktionen ACT_MTYPE. Returnerar
 *      modultyp fr aktiv modul, dvs. modulen p
 *      hgsta nivn, inte den som exekverar just nu.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv modultyp.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 *      23/9/93  pmrmod(), J. Kjellander
 *
 ******************************************************!*/

  {
    pm_ptr   oldmod;
    PMMODULE modhed;

/*
***Stt aktiv basadress till aktiv modul och spara
***nuvarande. Ls modulhuvudet och stt tillbaks
***aktiv basadress till det gamla vrdet igen.
*/
    oldmod = pmgbla();
    pmsbla(actmod);
    pmrmod(&modhed);
    pmsbla(oldmod);
/*
***Returnera modultyp.
*/
    valp->lit.int_va = modhed.mtype;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evamat(PMLITVA *valp)

/*      Evaluerar funktionen ACT_MATTR.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv moduls attribut.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 *      23/9/93  pmrmod(), J. Kjellander
 *
 ******************************************************!*/

  {
    pm_ptr   oldmod;
    PMMODULE modhed;

/*
***Stt aktiv basadress till aktiv modul och spara
***nuvarande. Ls modulhuvudet och stt tillbaks
***aktiv basadress till det gamla vrdet igen.
*/
    oldmod = pmgbla();
    pmsbla(actmod);
    pmrmod(&modhed);
    pmsbla(oldmod);
/*
***Returnera modulattribut.
*/
    valp->lit.int_va = modhed.mattri;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evajbd(PMLITVA *valp)

/*      Evaluerar funktionen ACT_JOBDIR.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt jobb direktory.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    strcpy(valp->lit.str_va , jobdir);

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evalft(PMLITVA *valp)
 
/*      Evaluerar funktionen ACT_LFONT.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv linjetyp.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.lfont;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evaaft(PMLITVA *valp)
 
/*      Evaluerar funktionen ACT_AFONT.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv cirkeltyp.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {
    valp->lit.int_va = defnap.afont;
    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evacft(PMLITVA *valp)
 
/*      Evaluerar funktionen ACT_CFONT.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv kurvtyp.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/1/92 J. Kjellander
 *
 ******************************************************!*/

  {
    valp->lit.int_va = defnap.cfont;
    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evaxft(PMLITVA *valp)
 
/*      Evaluerar funktionen ACT_XFONT.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv snittlinjetyp.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.xfont;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evaldl(PMLITVA *valp)

/*      Evaluerar funktionen ACT_LDASHL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv strecklngd fr linjer.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.ldashl;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evaadl(PMLITVA *valp)

/*      Evaluerar funktionen ACT_ADASHL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv strecklngd fr cirklar.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {
    valp->lit.float_va = defnap.adashl;
    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evacdl(PMLITVA *valp)

/*      Evaluerar funktionen ACT_CDASHL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv strecklngd fr kurvor.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/1/92 J. Kjellander
 *
 ******************************************************!*/

  {
    valp->lit.float_va = defnap.cdashl;
    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evaxdl(PMLITVA *valp)

/*      Evaluerar funktionen ACT_XLDASHL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv strecklngd fr snitt.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.xdashl;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evatsi(PMLITVA *valp)

/*      Evaluerar funktionen ACT_TSIZE.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv textstorlek.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.tsize;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evatwi(PMLITVA *valp)

/*      Evaluerar funktionen ACT_TWIDTH.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv textbredd.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.twidth;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evatsl(PMLITVA *valp)

/*      Evaluerar funktionen ACT_TSLANT.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv textlutning.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.tslant;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evadts(PMLITVA *valp)

/*      Evaluerar funktionen ACT_DTSIZ.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv mttextstorlek.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.dtsize;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evadas(PMLITVA *valp)

/*      Evaluerar funktionen ACT_DASIZ.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv mttpilstorlek.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.float_va = defnap.dasize;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evadnd(PMLITVA *valp)

/*      Evaluerar funktionen ACT_DNDIG.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt antal decimaler i mtt.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.dndig;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evadau(PMLITVA *valp)

/*      Evaluerar funktionen ACT_DAUTO.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Automatisk mttext ja/nej.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 31/10/86 R. Svedin
 *
 ******************************************************!*/

  {

    valp->lit.int_va = defnap.dauto;

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evacsy(PMLITVA *valp)

/*      Evaluerar funktionen ACT_CSY.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt koordinatsystem.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 6/2/95 J. Kjellander
 *
 ******************************************************!*/

  {

    if ( lsysla == DBNULL )
      {
      valp->lit.ref_va[0].seq_val = 0;
      valp->lit.ref_va[0].ord_val = 1;
      valp->lit.ref_va[0].p_nextre = NULL;
      }
    else
      {
      DBget_id(lsysla,&valp->lit.ref_va[0]);
      }

    return(0);

  }

/********************************************************/
/*!******************************************************/

        short evapid(PMLITVA *valp)

/*      Evaluerar funktionen ACT_PID.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt projektnamn.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/9/95 J. Kjellander
 *
 ******************************************************!*/

  {
    strcpy(valp->lit.str_va,pidnam);

    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evavvr(PMLITVA *valp)

/*      Evaluerar funktionen ACT_VARKON_VERSION.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv varkonversion.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/9/95 J. Kjellander
 *
 ******************************************************!*/

  {
    sprintf(valp->lit.str_va,"%d.%d%c",
            (int)sydata.vernr,(int)sydata.revnr,sydata.level);

    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evavsr(PMLITVA *valp)

/*      Evaluerar funktionen ACT_VARKON_SERIAL.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt serienummer.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/9/95 J. Kjellander
 *
 ******************************************************!*/

  {
    valp->lit.int_va = (v2int)sydata.sernr;

    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evaost(PMLITVA *valp)

/*      Evaluerar funktionen ACT_OSTYPE.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktiv OS-typ.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/9/95 J. Kjellander
 *
 ******************************************************!*/

  {
/*
***Defaultvrde.
*/
    strcpy(valp->lit.str_va,"unknown");

#ifdef UNIX
    strcpy(valp->lit.str_va,"UNIX");
#endif

#ifdef WIN32
    strcpy(valp->lit.str_va,"WIN32");
#endif

#ifdef VMS
    strcpy(valp->lit.str_va,"VMS");
#endif

    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evahst(PMLITVA *valp)

/*      Evaluerar funktionen ACT_HOST.
 *
 *      In: Inget.
 *
 *      Ut: *valp  = Aktivt nodnamn.
 *
 *      FV: Inget.
 *
 *      (C)microform ab 13/9/95 J. Kjellander
 *
 ******************************************************!*/

  {
#ifdef UNIX
    struct utsname name;
#endif

/*
***Defaultvrde.
*/
    strcpy(valp->lit.str_va,"unknown");
/*
***Alla UNIX-system br ha uname().
*/
#ifdef UNIX
    uname(&name);
    strcpy(valp->lit.str_va,name.nodename);
#endif

    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evcrnp(PMLITVA *valp)

/*      Evaluates CRAY_NUM_PES() on the T3E.
 *      On all other platforms it returns 1.
 *
 *      Out: *valp  = Number of PE:s currently executing.
 *
 *      (C)microform ab 1999-04-20 J. Kjellander
 *
 ******************************************************!*/

  {
/*
***Alla UNIX-system br ha uname().
*/
#ifdef _CRAYT3E
    valp->lit.int_va = _num_pes();
#else
    valp->lit.int_va = 1;
#endif

    return(0);
  }

/********************************************************/
/*!******************************************************/

        short evcrmp(PMLITVA *valp)

/*      Evaluates CRAY_MY_PE() on the T3E.
 *      On all other platforms it returns 0.
 *
 *      Out: *valp  = Number of this PE.
 *
 *      (C)microform ab 1999-04-20 J. Kjellander
 *
 ******************************************************!*/

  {
/*
***Alla UNIX-system br ha uname().
*/
#ifdef _CRAYT3E
    valp->lit.int_va = _my_pe();
#else
    valp->lit.int_va = 0;
#endif

    return(0);
  }

/********************************************************/
